unit FirstIndent;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// BeginExample: FirstIndent
// Property: ComCtrls.TCustomRichEdit.Lines
// Property: ComCtrls.TCustomRichEdit.Paragraph
// Property: ComCtrls.TParaAttributes.FirstIndent
// Property: ComCtrls.TParaAttributes.Numbering
// Type: Controls.TAlign
// Type: ComCtrls.TNumberingStyle
// Type: Classes.TAlignment

// BeginCode
{
This example requires only a form.  A Rich Edit control is
created on the form and aligned to take the entire client
area of the form.  A series of lines are written to the Rich
Edit control's Lines property, and the Paragraph property
manipulated such that the first items displayed are bulleted,
a second group of lines are unbulleted and centered, and the
last group is left justified and indented.
}
uses ComCtrls;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with TRichEdit.Create(Self) do
  begin
    Parent := Self;
    Align := alClient;
    Lines.Clear;
    // set numbering style
    Paragraph.Numbering := nsBullet;
    Lines.Add('Introduction');
    Lines.Add('New members to our team');
    Lines.Add('New Budget discussion');
    Lines.Add('Facilities');
    Lines.Add('Q & A');
    Paragraph.Numbering := nsNone;
    Paragraph.Alignment := taCenter;
    Lines.Add('');
    Lines.Add('Suggested Topics:');
    Lines.Add('');
    Paragraph.Alignment := taLeftJustify;
    Paragraph.FirstIndent := 10;
    Lines.Add('');
    Lines.Add('Parking lot repair');
    Lines.Add('Cost overruns');
  end;
end;
// EndCode
// EndExample: FirstIndent
end.
